
/*
TODO
 Create better status reporting
 Report next timer
 Report next turning on
 Report next turning off, incl run60 time
 Report total run time in minutes + RESET function
*/

#include <JacobTimerRelay.h>
	
JacobTimerRelay::JacobTimerRelay()
{
}


#ifdef UDPTRACING
	void JacobTimerRelay::configureTimerRelay(JacobServer* serverPtr, JacobTimer* timerPtr, rTraceClass* tracePtr, int timerIdNum, char* prefix, int relayPinNum, int relayONValue, int relayOFFValue)
#endif
#ifndef UDPTRACING
	void JacobTimerRelay::configureTimerRelay(JacobServer* serverPtr, JacobTimer* timerPtr, int timerIdNum, char* prefix, int relayPinNum, int relayONValue, int relayOFFValue)
#endif
{ 
  JacobTimerRelayEventStruct* event;

  
  timer=timerPtr;
  server=serverPtr;

#ifdef UDPTRACING
  trace = tracePtr;
#endif

  timerID = timerIdNum;
  relayPin=relayPinNum;
  relayON=relayONValue;
  relayOFF=relayOFFValue;
  
  pinMode(relayPin, OUTPUT);  

  event = new JacobTimerRelayEventStruct;
  event->timerRelayPtr=this;
  event->eventNumber=RELAYCALLBACK_INIT;

  timer->registerCallbackAtPLLLock(JacobTimerRelayCallbackHandler,(void*) event);

  strcpy(parameterPrefix, prefix);

  strcpy(parameterOnTimer, prefix);
  strcat(parameterOnTimer, ".OnCount");
  	
  strcpy(parameterTemp, prefix);
  strcat(parameterTemp, ".Temp");
  strcpy(parameterLastOn, prefix);
  strcat(parameterLastOn,".LastOn");
  strcpy(parameterLastOff, prefix);
  strcat(parameterLastOff,".LastOff");
  strcpy(parameterTotalOn, prefix);
  strcat(parameterTotalOn,".TotalOn");
  strcpy(parameterTimerServer, prefix);
  strcat(parameterTimerServer,".Timer");
  strcpy(parameterNextTimer, prefix);
  strcat(parameterNextTimer,".NextTimer");

  
  strcpy(lastOn,"Never On");
  strcpy(lastOff,"Never Off");
  temp=100.0;
  
  

  strcpy(parameterUpdate, prefix);
  strcat(parameterUpdate,".UPDATE");
  timerRelay[0].name=parameterUpdate;
  timerRelay[0].length=6;
  timerRelay[0].value=mUPDATE;

  strcpy(parameterRun60, prefix);
  strcat(parameterRun60,".Run60");
  timerRelay[1].name=parameterRun60;
  timerRelay[1].length=6;
  timerRelay[1].value=mRUN;

  strcpy(parameterStop, prefix);
  strcat(parameterStop,".Stop");
  timerRelay[2].name=parameterStop;
  timerRelay[2].length=6;
  timerRelay[2].value=mSTOP;

  
  
  strcpy(parameterOn1, prefix);
  strcat(parameterOn1,".On1");
  timerRelay[3].name=parameterOn1;
  timerRelay[3].length=10;
  timerRelay[3].value=tempmOn1;

  strcpy(parameterOff1, prefix);
  strcat(parameterOff1,".Off1");
  timerRelay[4].name=parameterOff1;
  timerRelay[4].length=10;
  timerRelay[4].value=tempmOff1;
  
  strcpy(parameterActive1, prefix);
  strcat(parameterActive1,".Active1");
  timerRelay[5].name=parameterActive1;
  timerRelay[5].length=6;
  timerRelay[5].value=tempmActive1;
 
  
  strcpy(parameterOn2, prefix);
  strcat(parameterOn2,".On2");
  timerRelay[6].name=parameterOn2;
  timerRelay[6].length=10;
  timerRelay[6].value=tempmOn2;
 
  strcpy(parameterOff2, prefix);
  strcat(parameterOff2,".Off2");
  timerRelay[7].name=parameterOff2;
  timerRelay[7].length=10;
  timerRelay[7].value=tempmOff2;
  
  strcpy(parameterActive2, prefix);
  strcat(parameterActive2,".Active2");
  timerRelay[8].name=parameterActive2;
  timerRelay[8].length=6;
  timerRelay[8].value=tempmActive2;

  
  strcpy(parameterOn3, prefix);
  strcat(parameterOn3,".On3");
  timerRelay[9].name=parameterOn3;
  timerRelay[9].length=10;
  timerRelay[9].value=tempmOn3;
 
  strcpy(parameterOff3, prefix);
  strcat(parameterOff3,".Off3");
  timerRelay[10].name=parameterOff3;
  timerRelay[10].length=10;
  timerRelay[10].value=tempmOff3;
  
  strcpy(parameterActive3, prefix);
  strcat(parameterActive3,".Active3");
  timerRelay[11].name=parameterActive3;
  timerRelay[11].length=6;
  timerRelay[11].value=tempmActive3;

  strcpy(parameterRunLength, prefix);
  strcat(parameterRunLength,".RunLength");
  timerRelay[12].name=parameterRunLength;
  timerRelay[12].length=6;
  timerRelay[12].value=tempmRunLength;

   

  manualTurnTimerRelayOff();

//  server->registerSubscription(NULL, NULL, NULL, NULL, 0,0);

  
  server->registerSubscription(parameterPrefix, parameterStop, JacobTimerRelaySubscriptionCallbackHander,(void*)this, 0,0);
  server->registerSubscription(parameterPrefix, parameterRun60, JacobTimerRelaySubscriptionCallbackHander,(void*)this, 1,0);
  server->registerSubscription(parameterPrefix, parameterUpdate, JacobTimerRelaySubscriptionCallbackHander,(void*)this, 2,0);
    
}

void JacobTimerRelay::firstCallFunction()
{
 timersRegistered=0;
  invalidateTimers=1;

}

void JacobTimerRelay::updatetimerRelayConfig()
{
  strcpy(mOn1,tempmOn1);
  strcpy(mOff1,tempmOff1);
  strcpy(mActive1,tempmActive1);
  strcpy(mOn2,tempmOn2);
  strcpy(mOff2,tempmOff2);
  strcpy(mActive2,tempmActive2);
  strcpy(mOn3,tempmOn3);
  strcpy(mOff3,tempmOff3);
  strcpy(mActive3,tempmActive3);
  strcpy(mRunLength,tempmRunLength);
  buttonRunLength=atol(mRunLength);
}


void JacobTimerRelay::turntimerRelayOn()
{
   timerHighEvent=1;
   timerLowEvent=0;
   timerOn=1;
}

void JacobTimerRelay::turntimerRelayOff()
{
   timerLowEvent=1;
   timerHighEvent=0;
   timerOn=0;
} 

void JacobTimerRelay::manualTurnTimerRelayOn()
{
   if (relayPin!=DUMMYRELAY) digitalWrite(relayPin, relayON);
   timerRelayON=1;
}

void JacobTimerRelay::manualTurnTimerRelayOff()
{
   if (relayPin!=DUMMYRELAY) digitalWrite(relayPin, relayOFF);
   timerRelayON=0;
} 

void JacobTimerRelay::eventHandler(int eventNumber)
{
	switch (eventNumber)
	{
		case RELAYCALLBACK_INIT: firstCallFunction(); break;
		case RELAYCALLBACK_ON: turntimerRelayOn();break;
		case RELAYCALLBACK_OFF: turntimerRelayOff();break;
		case RELAYCALLBACK_NEWDAY: settimerRelayTimers();break;
	}	
}

int JacobTimerRelay::addTimerCallback(long int ds, int eventNumber, int addAllways, int originID)
{
  int result;
  JacobTimerRelayEventStruct* event;
  event = new JacobTimerRelayEventStruct;
  event->timerRelayPtr=this;
  event->eventNumber=eventNumber;
  result=timer->addTimer(ds,(void*) event, JacobTimerRelayCallbackHandler,addAllways, originID);
  if (result==-1) delete event;
  return result;
}

void JacobTimerRelay::startRun60(long int runTime)
{
	run60EndTime=timer->arduinoTime() + runTime; //1h
	run60Active=1;
#ifdef UDPTRACING
    trace->start(parameterPrefix);
	trace->appendString(": StartRun60");
	trace->send(1);
#endif
	strcpy(mRUN,"FALSE");
}

void JacobTimerRelay::settimerRelayTimers()
{
  struct TimeOfDayStruct t;
  int i;
  char tString[40];
  char* updateTimeOfDay="02:00:00";


  timer->predictCurrentTime(&t);
#ifdef UDPTRACING
  trace->start(parameterPrefix);
  trace->appendString(": Prepare Timers: ");
  trace->send(1);
#endif
  timersRegistered=1;

  if (strcmp(mActive1,"TRUE")==0)
  {
     timer->setTimeToday(&t,mOn1);
#ifdef UDPTRACING
	 trace->start(mOn1);
     trace->appendString(" (");	 
	 trace->appendLongInt(t.ds);
#endif
     addTimerCallback(t.ds,RELAYCALLBACK_ON,1, timerID);
     timer->setTimeToday(&t,mOff1);
     addTimerCallback(t.ds, RELAYCALLBACK_OFF,1, timerID);
#ifdef UDPTRACING
	 trace->appendString(") to ");
	 trace->appendString(mOff1);
	 trace->appendString(" (");
	 trace->appendLongInt(t.ds);
	 trace->appendString(" )");
	 trace->send(1);
#endif
  }

  if (strcmp(mActive2,"TRUE")==0)
  {
     timer->setTimeToday(&t,mOn2);
#ifdef UDPTRACING
	 trace->start(mOn2);
     trace->appendString(" (");	 
	 trace->appendLongInt(t.ds);
#endif
     addTimerCallback(t.ds, RELAYCALLBACK_ON,1, timerID);
     timer->setTimeToday(&t,mOff2);
     addTimerCallback(t.ds, RELAYCALLBACK_OFF,1, timerID);
#ifdef UDPTRACING
	 trace->appendString(") to ");
	 trace->appendString(mOff2);
	 trace->appendString(" (");
	 trace->appendLongInt(t.ds);
	 trace->appendString(" )");
	 trace->send(1);
#endif
  }

  if (strcmp(mActive3,"TRUE")==0)
  {
     timer->setTimeToday(&t,mOn3);
#ifdef UDPTRACING
	 trace->start(mOn3);
     trace->appendString(" (");	 
	 trace->appendLongInt(t.ds);
#endif
     addTimerCallback(t.ds,RELAYCALLBACK_ON,1, timerID);
     timer->setTimeToday(&t,mOff3);
     addTimerCallback(t.ds,RELAYCALLBACK_OFF,1, timerID);
#ifdef UDPTRACING
	 trace->appendString(") to ");
	 trace->appendString(mOff3);
	 trace->appendString(" (");
	 trace->appendLongInt(t.ds);
	 trace->appendString(" )");
	 trace->send(1);
#endif
  }

  timer->setTimeTomorrow(&t,updateTimeOfDay);
  addTimerCallback(t.ds, RELAYCALLBACK_NEWDAY,1, timerID);

#ifdef UDPTRACING
    for (i=0;i<NUMOFTIMERS;i++)
       if (timer->timers[i].active==1)
       {
		 trace->start("Active timer: ");
		 trace->appendInt(i);
		 trace->appendString(" set by id = ");
		 trace->appendInt(timer->timers[i].originID);
		 trace->appendString(", expires in ");
         timer->printDsToString(timer->timers[i].timerDs - timer->arduinoTime(),tString);
		 trace->appendString(tString);
		 trace->send(1);
       } 
#endif
}

void JacobTimerRelay::cleartimerRelayTimers()
{
   timer->removeTimers(timerID);
   turntimerRelayOff();
//   Serial.print("Remove Timers: ");
//   timer->printTimers();
}

void JacobTimerRelay::registerTemp(float t)
{
	temp=t;
}


void JacobTimerRelay::updateTimerRelay()
{
  float t,h,u;
  int k;
  char outbuf[300];
  char inbuf[500];
  char tempString[20];
  int oldTimerRelayON=timerRelayON;


  if (run60EndTime<timer->arduinoTime()) run60Active=0;
  
//  Serial.println("A");
  
  server->checkReceivedPacket();

//   Serial.println("B");
 
  switch (state)
  {
	  case 0: //Relay off
	     if (timerHighEvent==1) state=1;
		 if (run60Active==1) state=2;
		 if (toggleEvent==1) 
		 {
			 if (buttonRunLength==0L)
			 {
				 state=1;
			 } else {
				 state=2;
				 run60Active=1;
				 startRun60(600L*buttonRunLength);
			 }
		 }
		 break;
	  case 1: //Relay on due to timer
	     if (toggleEvent==1) state=0;
		 if (run60Active==1) state=2;
		 if (stopEvent==1) state=0;
		 if (timerLowEvent==1) state=0;
		 break;
	  case 2: //Relay on due to run60 or toggle
		 if (run60Active==0)
		 {
		    if (timerOn==1) state=1; else state=0;
		 }
	     if (toggleEvent==1) {state=0; run60Active=0;}
		 if (stopEvent==1) {state=0; run60Active=0;}
		 break;
  }
  if ((state==0) && (forceOn==0))
  {
	  manualTurnTimerRelayOff();
  } else  {
	  manualTurnTimerRelayOn();
  }
	
//  Serial.println("C");
	
  if (timerRelayON!=oldTimerRelayON)
  {
	  if (timerRelayON==1)
	  {
  	     timerRelayONTime=timer->arduinoTime();
		 lastOnReport=timerRelayONTime-TIMERONUPDATEINTERVAL-1;  //Ensure report at once
	  } else {
         mOnCount=0;
		 server->createStoreMessage(outbuf,parameterPrefix);
         server->appendStoreMessageInt(outbuf,parameterOnTimer,mOnCount);
         server->pushToServer(outbuf);  
		 Serial.println("Sent OnCount value");
  	     //relay was turned off
	  }
  }
  
//  Serial.println("D");

  toggleEvent=0;
  stopEvent=0;
  timerHighEvent=0;
  timerLowEvent=0;
  
  
  
  timer->updatePLL();
  timer->checkTimers();
  

//  Serial.println("E");


  if (timerRelayON==1)
  {
     mOnCount = (int)((timer->arduinoTime()-timerRelayONTime)/10)+1;  //Report 1s too much
  }

  if ((timerRelayON==1) && ((lastOnReport+TIMERONUPDATEINTERVAL < timer->arduinoTime()) && (mOnCount<4)))  //Only quick report first 3s
  {
     server->createStoreMessage(outbuf,parameterPrefix);
     server->appendStoreMessageInt(outbuf,parameterOnTimer,mOnCount);
     server->pushToServer(outbuf);  
	 lastOnReport = timer->arduinoTime();
  }

  if ((invalidateTimers==0) && (lastParameterRead+TIMERUPDATEINTERVAL > timer->arduinoTime()) )
  {
	  return;
  }
  
  invalidateTimers=0;
//  Serial.println("F");
  
  if (timerRelayON==1)
  {
#ifdef UDPTRACING
	 if (timerRelayOnTrace==1)
	 {
		 trace->start(parameterPrefix);
		 trace->appendString(": Relay on for ");
		 trace->appendInt(mOnCount);
		 if (run60Active==1) 
		 {
			 trace->appendString("s, stops in ");
			 trace->appendLongInt(run60EndTime-timer->arduinoTime());
			 trace->appendString("ds");
		 } else
			trace->appendString("s");
		 trace->send(1);
	 }
#endif
  }
  else
     mOnCount=0;
 
 
   server->updateSubscriptions(parameterPrefix);

//  Serial.println("G");

 
  timer->printDsToString(timer->nextTimerMyID(timerID)-timer->arduinoTime(), tempString);

  server->createStoreMessage(outbuf,parameterPrefix);
  server->appendStoreMessageInt(outbuf,parameterOnTimer,mOnCount);
  server->appendStoreMessageFloat(outbuf,parameterTemp,temp);
  server->appendStoreMessageString(outbuf,parameterLastOn,lastOn);
  server->appendStoreMessageString(outbuf,parameterLastOff,lastOff);
  server->appendStoreMessageFloat(outbuf,parameterTotalOn,(float)(totalOn+mOnCount)/60.0);
  server->appendStoreMessageString(outbuf,parameterTimerServer,timer->clientName);
  server->appendStoreMessageString(outbuf,parameterNextTimer,tempString);

 
  server->pushToServer(outbuf);
  server->registerService("timerRelay", parameterPrefix, "1", parameterPrefix);

//  Serial.println("H");

  server->createReadMessage(inbuf, parameterPrefix);
  server->appendReadMessageEntries(inbuf,timerRelay,13);
  k=server->readFromServer(inbuf,inbuf,500);
  
//  Serial.println("I");

//  Serial.println(inbuf);

  if (k!=-1)
  {
    readResult=server->getParameterEntries(inbuf,timerRelay,13);
	
    if ((timerRelay[2].readResult == 0) && (strcmp(mSTOP,"TRUE")==0))
    {
		stopEvent=1;
#ifdef UDPTRACING
		trace->start(parameterPrefix);
		trace->appendString(": STOP");
		trace->send(1);
#endif
        manualTurnTimerRelayOff();
        server->createStoreMessage(outbuf,parameterPrefix);
        server->appendStoreMessageString(outbuf,parameterUpdate,"FALSE");
        server->appendStoreMessageString(outbuf,parameterRun60,"FALSE");
        server->appendStoreMessageString(outbuf,parameterStop,"FALSE");
        server->pushToServer(outbuf);  
		mOnCount=0;
    } else {
	  if (readResult==0) lastParameterRead = timer->arduinoTime();	//Successful read => store time
      if ((readResult==0) && ((strcmp(mUPDATE,"NEW")==0) || timersRegistered==0))
      {
		  
#ifdef UDPTRACING
 		  trace->start(parameterPrefix);
		  trace->appendString(": Updating");
		  trace->send(1);
#endif
          server->createStoreMessage(outbuf,parameterPrefix);
          server->appendStoreMessageString(outbuf,parameterRun60,"FALSE");
          server->appendStoreMessageString(outbuf,parameterUpdate,"FALSE");

          server->pushToServer(outbuf);  
          updatetimerRelayConfig();
//		  trace->start("Updated: ");
//		  trace->appendLongInt(buttonRunLength);
//		  trace->send(1);
          cleartimerRelayTimers();
          settimerRelayTimers();
          if (strcmp(mRUN,"TRUE")==0) 
		  {
			  startRun60(run60TimeToRun);
		  } else {
			  run60Active=0;
		  }
      } 
    }
  }


}

void JacobTimerRelayCallbackHandler(void* data)
{
	JacobTimerRelayEventStruct* event;
	event = (JacobTimerRelayEventStruct*) data; 
	event->timerRelayPtr->eventHandler(event->eventNumber);
	delete event;
}

void JacobTimerRelay::subscriptionCallback(int arg1,int arg2, char* buffer)
{
	char resultString[16];
	Serial.println("subscriptionCallback() ");



	switch (arg1) 
	{
		case 0: //STOP
  		   server->getParameterString(buffer,parameterStop,resultString,16);
		   if (strcmp(resultString,"TRUE")==0) {
				 stopEvent=1;
				 manualTurnTimerRelayOff();
				 invalidateTimers=1;
				 Serial.println("UDP caused relay to STOP");
		   }
		   break;
		case 1: //Run60
  		   server->getParameterString(buffer,parameterRun60,resultString,16);
		   if (strcmp(resultString,"TRUE")==0) {
				 invalidateTimers=1;
				 startRun60(run60TimeToRun);
				 Serial.println("UDP caused relay to Run60");
		   }
		   break;
		case 2: //Update
		   server->getParameterString(buffer,parameterUpdate,resultString,16);
		   if (strcmp(resultString,"NEW")==0) {
			  invalidateTimers=1;
				 Serial.println("UDP caused relay to Update Timers");
		   }
		   break;
	}
	updateTimerRelay();
}
		   
			
		   

void JacobTimerRelaySubscriptionCallbackHander( void* ptr,  int arg1,  int arg2,  char* buffer)
{
	JacobTimerRelay* timerRelayPtr;
	Serial.println("JacobTimerRelayCallbackHandler()");
	/*Serial.print(arg1);
	Serial.print(":");
	Serial.println(buffer);*/
	timerRelayPtr = (JacobTimerRelay*) ptr;
	timerRelayPtr->subscriptionCallback(arg1, arg2, buffer);
	

}


void JacobTimerRelay::manualToggle()
{
   toggleEvent=1;
}


void JacobTimerRelay::manualOn()
{
   forceOn=1;
}

void JacobTimerRelay::manualNotOn()
{
   forceOn=0;
}
