
#ifndef JacobTimerRelay_h
#define JacobTimerRelay_h


#include "Arduino.h"

#include <JacobTimer.h>

#define UDPTRACING

#ifdef UDPTRACING
#include <rTrace.h>
#endif

//Update interval in 10:ths of seconds (20 = every 2)
#define TIMERUPDATEINTERVAL 600 
#define TIMERONUPDATEINTERVAL 10
#define TIMERONRESPONSEINTERVAL 10
#define DUMMYRELAY -1

#define RELAYCALLBACK_ON 1
#define RELAYCALLBACK_OFF 2
#define RELAYCALLBACK_INIT 0
#define RELAYCALLBACK_NEWDAY 3
#define RELAYREADBUFFERSIZE 64

class JacobTimerRelay {
   public:


	int invalidateTimers=0;
   
    char parameterPrefix[30];
	char parameterOnTimer[40];
	char parameterUpdate[40];
	char parameterRun60[40];
	char parameterStop[40];
	char parameterOn1[40];
	char parameterOff1[40];
	char parameterActive1[40];
	char parameterOn2[40];
	char parameterOff2[40];
	char parameterActive2[40];
	char parameterOn3[40];
	char parameterOff3[40];
	char parameterActive3[40];
	char parameterRunLength[40];
	
	char parameterTemp[40];
	char parameterLastOn[40];
	char parameterLastOff[40];
	char parameterTotalOn[40];
	char parameterTimerServer[40];
	char parameterNextTimer[40];

	long int totalOn=0L;
	char lastOn[30];
	char lastOff[30];
	float temp=100.0;


	char mOn1[10];
	char mOff1[10];
	char mActive1[6];
	char mOn2[10];
	char mOff2[10];
	char mActive2[6];
	char mOn3[10];
	char mOff3[10];
	char mActive3[6];
	char mRunLength[6];

	char tempmOn1[10];
	char tempmOff1[10];
	char tempmActive1[6];
	char tempmOn2[10];
	char tempmOff2[10];
	char tempmActive2[6];
	char tempmOn3[10];
	char tempmOff3[10];
	char tempmActive3[6];
	char tempmRunLength[6];

	char mUPDATE[6];
	char mRUN[6];
	char mSTOP[6];
	int mOnCount=0;
	int timerRelayON=0;
	int readResult=0;

	JacobServer* server;
	JacobTimer* timer;
#ifdef UDPTRACING
    rTraceClass* trace;
#endif	

	long int timerRelayONTime=0L;
	long int run60EndTime=0L;
	long int run60TimeToRun = 36000L;
	long int buttonRunLength=0L;
	int run60Active=0;

	int timersRegistered=-1;

	ParameterEntry timerRelay[13];
	
	int timerID=0;
	
	int relayPin=0;

	int relayON=0;
	int relayOFF=0;
	int timerOn=0;
	
	int timerHighEvent=0;
	int timerLowEvent=0;
	int toggleEvent=0;
	int stopEvent=0;
	
	int forceOn=0;
	
	
	int state=0;
	long int lastParameterRead=0L;
	long int lastOnReport=0L;
	int timerRelayOnTrace=1;
	
//    void (*callbackAtPLLLock)();
	
	JacobTimerRelay();
#ifdef UDPTRACING
	void configureTimerRelay(JacobServer* serverPtr, JacobTimer* timerPtr, rTraceClass* tracePtr, int timerIdNum, char* prefix, int relayPinNum, int relayONValue, int relayOFFValue);
#endif
#ifndef UDPTRACING
	void configureTimerRelay(JacobServer* serverPtr, JacobTimer* timerPtr, int timerIdNum, char* prefix, int relayPinNum, int relayONValue, int relayOFFValue);
#endif
	void updatetimerRelayConfig();
	void firstCallFunction();
	void turntimerRelayOn();
	void turntimerRelayOff();
	void manualTurnTimerRelayOn();
	void manualTurnTimerRelayOff();
	void settimerRelayTimers();
	void cleartimerRelayTimers();
	void updateTimerRelay();
	void eventHandler(int eventNumber);
	int addTimerCallback(long int ds, int eventNumber, int addAllways, int originID);
	void startRun60(long int runTime);
	void registerTemp(float t);
	void manualOn();
	void manualNotOn();
	void manualToggle();
	void subscriptionCallback( int arg1,  int arg2,  char* buffer);

};

struct JacobTimerRelayEventStruct
{
	JacobTimerRelay* timerRelayPtr;
	int eventNumber;
};

void JacobTimerRelayCallbackHandler(void* data);
void JacobTimerRelaySubscriptionCallbackHander( void* ptr,  int arg1,  int arg2,  char* buffer);

#endif
	